/* =================================================================================
 *  parentetica.h
 * =================================================================================
 * Contiene la definizione di lista e di albero binario (di caratteri).
 * Contiene inoltre il prototipo delle seguenti funzioni e procedure:
 * - costruzione di una lista di caratteri
 * - stampa del contenuto di una lista di caratteri
 * - stampa indentata di un albero binario
 * - verifica se una lista contiene una rappresentazione parentetica legale di un 
 *   albero binario, e in tal caso costruisce l'albero
 *
 *  Author:      Irene Finocchi  (finocchi@di.uniroma1.it)
 *  Last change: 16 Aprile 2005
 *  Changed by:  Irene Finocchi
*/

#ifndef PARENTETICA_H
#define PARENTETICA_H

#include <stdio.h>
#include<stdlib.h>

/* Tipi albero e lista */

struct nodoalbero{
	struct nodoalbero *rPtr;
	char elem;
	struct nodoalbero *lPtr;
};

typedef struct nodoalbero *TreePtr;

struct nodolista{
	char elem;
	struct nodolista *next;
};

typedef struct nodolista *ListPtr;

/* Prototipi */

/* Costruzione di una lista di caratteri da input */
ListPtr crealista();

/* Post: stampa il contenuto della lista */
void stampaLista(ListPtr L);

/* Realizza una stampa indentata di un albero binario */
void stampaIndentata(TreePtr, int);

/* Verifica se il contenuto della lista e' una rappresentazione parentetica
   legale di un albero binario: se si, costruisce l'albero; se no, restituisce NULL */
TreePtr ListToTree(ListPtr);

#endif
